var SelectInlineController = (function(_super){
  __extends(_SelectInlineController, _super);

  function _SelectInlineController($scope, $rootScope, metaDataFactory, templateManager, ScreenService, ZhUtil, SelectService, ZHPromise, maskEngine, EventChildPropagation){
    $scope.field = $scope.column;

    var _ref = SelectInlineController.__super__.constructor.apply(this, arguments);

    function setInlineCache(row, prop){
      row[prop + '_inline'] = row[prop];
    }

    function setInlineValue(row, prop){
      row[prop] = row[prop + '_inline'];
    }

    $scope.clearField = function(field, row){
      setInlineCache(row, field.name);
      for(var prop in field.outData) {
        setInlineCache(row, field.outData[prop]);
        row[field.outData[prop]] = "";
      }
      row[field.name] = "";
      row.changed = true;
      field.widget.inlineEdit();
    };

    this.changeByName = function(field, row) {
      var valueField = field.valueField || field.name;
      var descriptionField = field.descriptionField || field.name;
      field.widget.currentRow[valueField] = row[valueField];
      field.widget.currentRow[field.name] = row[descriptionField];
      field.widget.inlineEdit();
    };

    this.changeByOut = function(field, row) {
      Object.keys(field.outData).forEach(function(prop) {
        if(Array.isArray(field.outData[prop])) {
          field.outData[prop].forEach(function(value) {
            field.widget.currentRow[value] = row[prop];
          });
        } else {
          field.widget.currentRow[field.outData[prop]] = row[prop];
        }
      });
      field.widget.inlineEdit();
    };

    this.afterClosePopup = function(field) {
      field.widget.inlineEditing = false;
    };

    function inlineEditAction(changedRows, field, setter) {
      changedRows.forEach(function(row) {
        setter(row, field.name);
        for(var prop in field.outData){
          setter(row, field.outData[prop]);
        }
      });
      field.widget.list();
    }

    $scope.field.widget.onCancelInlineEdit = function(data) {
      inlineEditAction(data.data.changedRows, this, setInlineValue);
    }.bind($scope.field);

    $scope.field.widget.onSaveInlineEdit = function(data) {
      inlineEditAction(data.data.changedRows, this, setInlineCache);
    }.bind($scope.field);

    return _ref;
  }
  return _SelectInlineController;
})(SelectController);